// Generated by CoffeeScript 2.0.2
(function() {
  // H9 uses the AWS-SDK and your credentials to directly interact with Amazon.
  var AWS, async, awsPath, bind, homedir, isFunction, join, lift, liftModule, parseCreds, read, task, where;

  ({join} = require("path"));

  ({homedir} = require("os"));

  AWS = require("aws-sdk");

  ({async, read, isFunction, where, lift} = require("fairmont"));

  ({task} = require("panda-9000"));

  // this should be in f-core
  bind = function(o, f) {
    return f.bind(o);
  };

  liftModule = function(m) {
    var k, lifted, v;
    lifted = {};
    for (k in m) {
      v = m[k];
      lifted[k] = isFunction(v) ? lift(v.bind(m)) : v;
    }
    return lifted;
  };

  parseCreds = function(data) {
    var get, lines;
    lines = data.split("\n");
    get = function(line) {
      return line.split(/\s*=\s*/)[1];
    };
    where = function(phrase) {
      var i, j, ref;
      for (i = j = 0, ref = lines.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        if (lines[i].indexOf(phrase) >= 0) {
          return i;
        }
      }
    };
    return {
      id: get(lines[where("aws_access_key_id")]),
      key: get(lines[where("aws_secret_access_key")])
    };
  };

  // Looks for AWS credentials stored at ~/.aws/credentials
  awsPath = join(homedir(), ".aws", "credentials");

  module.exports = async(function*(region) {
    var acm, cf, id, key, repoConfig, route53, s3;
    ({id, key} = parseCreds((yield read(awsPath))));
    repoConfig = require("./configuration");
    AWS.config = {
      accessKeyId: id,
      secretAccessKey: key,
      region: region || repoConfig.aws.region,
      sslEnabled: true
    };
    // Module's we'd like to invoke from AWS are listed and lifted here.
    acm = liftModule(new AWS.ACM());
    cf = liftModule(new AWS.CloudFront());
    route53 = liftModule(new AWS.Route53());
    s3 = liftModule(new AWS.S3());
    return {acm, cf, route53, s3};
  });

}).call(this);
