// Generated by CoffeeScript 2.0.2
(function() {
  var call, join, program, read, run;

  ({join} = require("path"));

  program = require("commander");

  ({call, read} = require("fairmont"));

  require("./index");

  ({run} = require("panda-9000"));

  // exit on ctrl-c, related signals
  // https://github.com/pandastrike/haiku9/issues/88
  process.on('SIGHUP', function() {
    return process.exit();
  });

  process.on('SIGINT', function() {
    return process.exit();
  });

  process.on('SIGQUIT', function() {
    return process.exit();
  });

  process.on('SIGABRT', function() {
    return process.exit();
  });

  process.on('SIGTERM', function() {
    return process.exit();
  });

  call(function*() {
    var version;
    ({version} = JSON.parse((yield read(join(__dirname, "..", "package.json")))));
    program.version(version);
    program.command('serve').description('run a Web server to serve your content').action(function() {
      return run("serve");
    });
    program.command('build').description('compile the Website assets into the "target" directory').action(function() {
      return run("build");
    });
    program.command('publish [env]').description('deploy Website assets from "target" to AWS infrastructure').option("-f, --force", "force the upload of all files, ignoring cloud sync comparisons").option("--nobuild", "publish the repository without issuing a build job beforehand").action(function(env, options) {
      if (!env) {
        console.error("No environment has been provided.");
        console.error("Usage: h9 publish <environment>");
        process.exit(1);
      }
      if (options.nobuild) {
        return run("nobuildPublish", [env, options]);
      } else {
        return run("publish", [env, options]);
      }
    });
    // Begin execution.
    return program.parse(process.argv);
  });

}).call(this);
