// Generated by CoffeeScript 2.0.2
(function() {
  // We cannot use the configuration directly.  To make the code and the CLI more
  // flexible, we need to construct a data object that's slightly streamlined
  // from the one set by the user in h9.yaml
  var collect, empty, setDefaultCFHeaderConfig, where;

  ({collect, where, empty} = require("fairmont"));

  setDefaultCFHeaderConfig = require("./headers");

  module.exports = function(config, env) {
    var aws, defs, i, len, name, names, out, ref;
    out = config;
    defs = config._defs;
    ({aws} = config);
    // Pull config data for the requested environment.
    env = aws.environments[env];
    if (!env) {
      console.error("Cannot find config for specified environment. Aborting.");
      throw new Error();
    }
    // Construct an array of full subdomains to feed the process.
    names = [];
    ref = env.hostnames;
    for (i = 0, len = ref.length; i < len; i++) {
      name = ref[i];
      names.push(name + "." + aws.domain);
    }
    if (env.apex === "primary") {
      names.unshift(aws.domain);
    }
    if (env.apex === "secondary") {
      names.push(aws.domain);
    }
    out.aws.hostnames = names;
    // Pull CloudFront (cdn / caching) info into the config
    out.aws.cache = env.cache;
    if (out.aws.cache && !out.aws.cache.headers) {
      // Validate that the cache.headers (CloudFront CORS) configuration is consistent
      // with the CORS configuration on the S3 bucket
      out = setDefaultCFHeaderConfig(out, defs);
    }
    // Return the compiled config.
    return out;
  };

}).call(this);
