// Generated by CoffeeScript 2.0.2
(function() {
  var async, collect, empty, where,
    indexOf = [].indexOf;

  ({async, collect, where, empty} = require("fairmont"));

  module.exports = function(config, acm) {
    var apex, fetch, getCertList, match, regularlyQualify, root, wild;
    // TODO: Consider how to handle multiple region cert placement.
    ({root, regularlyQualify} = require("../url")(config));
    wild = function(name) {
      return regularlyQualify("*." + root(name));
    };
    apex = function(name) {
      return regularlyQualify(root(name));
    };
    getCertList = async(function*() {
      var data;
      data = (yield acm.listCertificates({
        CertificateStatuses: ["ISSUED"]
      }));
      return data.CertificateSummaryList;
    });
    // Look for certs that contain wildcard permissions
    match = async(function*(name, list) {
      var alternates, cert, certs, data, i, len, ref;
      certs = collect(where({
        DomainName: wild(name)
      }, list));
      if (!empty(certs)) { // Found what we need.
        return certs[0].CertificateArn;
      }
      
      // No primary wildcard cert.  Look for apex.
      certs = collect(where({
        DomainName: apex(name)
      }, list));
      for (i = 0, len = certs.length; i < len; i++) {
        cert = certs[i];
        data = (yield acm.describeCertificate({
          CertificateArn: cert.CertificateArn
        }));
        alternates = data.Certificate.SubjectAlternativeNames;
        if (ref = wild(name), indexOf.call(alternates, ref) >= 0) {
          return cert.CertificateArn;
        }
      }
      return false; // Failed to find wildcard cert among alternate names.
    });
    fetch = async(function*(name) {
      var arn, e;
      try {
        arn = (yield match(name, (yield getCertList())));
      } catch (error) {
        e = error;
        console.error("Unexpected response while searching SSL certs.", e);
        throw new Error();
      }
      if (!arn) {
        console.error("You do not have an active certificate for", wild(name));
        throw new Error();
      } else {
        return arn;
      }
    });
    return {fetch};
  };

}).call(this);
