// Generated by CoffeeScript 2.0.2
(function() {
  var async, isArray, sleep;

  ({async, sleep, isArray} = require("fairmont"));

  // Handles setting up and maintaining CloudFront distributions.
  module.exports = async(function*(config, cf) {
    cf = (yield require("./distribution")(config, cf));
    return {
      // Locate a CloudFront distribution that matches our needs or create it.
      set: async(function*() {
        var j, len, name, ref, results;
        if (config.aws.cache.ssl) {
          console.log("===== Using CloudFront CDN. HTTPS with redirect.");
        } else {
          console.log("===== Using CloudFront CDN. HTTP-Only.");
        }
        ref = config.aws.hostnames;
        results = [];
        for (j = 0, len = ref.length; j < len; j++) {
          name = ref[j];
          results.push((yield cf.set(name)));
        }
        return results;
      }),
      // Wait until we're sure everything is ready on the edge servers.  For new
      // distributions, that means waiting until we get a `Deployed` status. And
      // we also need to issue cache invalidations if there are content updates.
      sync: async(function*(distributions, changes) {
        var distro, i, invalidations, j, k, l, len, len1, pluralString, ref;
        pluralString = distributions.length > 1 ? "s are " : " is ";
        console.log(`\n======\nConfirming CloudFront distribution${pluralString}synchronized.`);
        for (j = 0, len = distributions.length; j < len; j++) {
          distro = distributions[j];
          yield cf.sync(distro);
        }
        console.log(`CloudFront distribution synchronization${pluralString}complete.`);
        if (config.aws.cache.expires !== 0 && cf.needsInvalidation(changes)) {
          console.log("Invalidating CDN cache. This may take several minutes.");
          invalidations = [];
          for (k = 0, len1 = distributions.length; k < len1; k++) {
            distro = distributions[k];
            invalidations.push((yield cf.invalidate(distro)));
          }
          for (i = l = 0, ref = distributions.length; 0 <= ref ? l < ref : l > ref; i = 0 <= ref ? ++l : --l) {
            yield cf.syncInvalidation(distributions[i], invalidations[i]);
          }
        }
        console.log("CDN cache validation check complete.");
        return console.log("=====\n");
      })
    };
  });

}).call(this);
