// Generated by CoffeeScript 2.0.2
(function() {
  var async, config, sleep;

  ({async, sleep} = require("fairmont"));

  config = require("../../../configuration");

  // Handles setting up DNS records to assign the desired hostname to the bucket.
  module.exports = function(config, route53) {
    var dns;
    dns = require("./dns")(config, route53);
    return {
      set: async(function*(distributions) {
        var data, e, params;
        console.log("\n=====");
        console.log("-- Establishing DNS record for site.");
        if (!distributions) {
          console.log("-- Direct S3 Serving.  HTTP-Only.");
        }
        params = (yield dns.build(distributions));
        try {
          if (!params) {
            return false;
          }
          data = (yield route53.changeResourceRecordSets(params));
          return data.ChangeInfo.Id;
        } catch (error) {
          e = error;
          console.error("Unexpected reply while setting DNS record", e);
          throw new Error();
        }
      }),
      sync: async(function*(id) {
        var data, e;
        if (id) {
          console.log("-- Waiting for DNS records to synchronize.");
        } else {
          console.log("-- DNS up to date.  Skipping.");
          return true;
        }
        try {
          while (true) {
            data = (yield route53.getChange({
              Id: id
            }));
            if (data.ChangeInfo.Status === "INSYNC") {
              return true;
            } else {
              yield sleep(5000);
            }
          }
        } catch (error) {
          e = error;
          console.error("Unexpected reply while checking sync of DNS record.", e);
          throw new Error();
        }
      })
    };
  };

}).call(this);
