// Generated by CoffeeScript 2.0.2
(function() {
  var async, config, rest;

  ({async, rest} = require("fairmont"));

  config = require("../../configuration");

  module.exports = function(config, s3) {
    return {
      // Sets the S3 bucket's static site configuration.
      enable: async(function*() {
        var e, i, len, name, params, ref, ref1, results;
        console.log("Configuring S3 bucket for static serving.");
        params = {
          Bucket: config.aws.hostnames[0],
          WebsiteConfiguration: {
            ErrorDocument: {
              Key: config.aws.site.error.toString()
            },
            IndexDocument: {
              Suffix: config.aws.site.index.toString()
            }
          }
        };
        try {
          yield s3.putBucketWebsite(params);
        } catch (error) {
          e = error;
          console.error("Unexpected reply while setting bucket's site config", e);
          throw new Error();
        }
        ref = rest(config.aws.hostnames);
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          name = ref[i];
          params = {
            Bucket: name,
            WebsiteConfiguration: {
              RedirectAllRequestsTo: {
                HostName: config.aws.hostnames[0],
                Protocol: ((ref1 = config.aws.cache) != null ? ref1.ssl : void 0) ? "https" : "http"
              }
            }
          };
          try {
            results.push((yield s3.putBucketWebsite(params)));
          } catch (error) {
            e = error;
            console.error("Unexpected reply while setting bucket's site config", e);
            throw new Error();
          }
        }
        return results;
      })
    };
  };

}).call(this);
