// Generated by CoffeeScript 2.0.2
(function() {
  // Haiku9 relies on the MD5 message digest algorithm to create a hash for each
  // file. We can then reference that hash to determine if data stored in an S3
  // object needs to be updated.
  var async, collect, curry, exclude, flow, lsR, map, md5, mime, pull, read, target,
    indexOf = [].indexOf;

  mime = require("mime");

  ({async, lsR, collect, flow, map, pull, read, md5, curry} = require("fairmont"));

  ({target} = require("../configuration"));

  exclude = curry(function(exclusions, path) {
    var e, j, len;
    for (j = 0, len = exclusions.length; j < len; j++) {
      e = exclusions[j];
      if (path.match(new RegExp(`^${e}.*$`))) {
        return true;
      }
    }
    return false;
  });

  module.exports = {
    // Produce a table of filenames and their md5 hashes.
    scan: async(function*() {
      var hashes, i, j, path, paths, ref, table;
      console.log("-- Scanning local repo.");
      table = {};
      paths = (yield lsR(target));
      hashes = (yield collect(flow([
        paths,
        map(function(pathname) {
          if (indexOf.call(mime.lookup(pathname),
        "text") >= 0) {
            return read(pathname);
          } else {
            return read(pathname,
        "buffer");
          }
        }),
        pull,
        map(function(content) {
          return md5(content);
        })
      ])));
      for (i = j = 0, ref = paths.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        path = paths[i].split(target + "/")[1];
        table[path] = hashes[i];
      }
      return table;
    }),
    // Produce an array of tasks to make the S3 bucket sync with the local files.
    reconcile: function(local, remote, {exclusions, force}) {
      var dlist, isExcluded, k, needsUpdate, obj, ulist, v;
      // Files need to be uploaded or deleted from S3.
      dlist = [];
      ulist = [];
      for (k in remote) {
        v = remote[k];
        if (k.match(/.*\/$/)) {
          // Ignore keys that signify a directory, instead of a flat data object.
          delete remote[k];
        }
      }
      // Ignore exluded files.
      if (exclusions) {
        isExcluded = exclude(exclusions);
        for (k in remote) {
          v = remote[k];
          if (isExcluded(k)) {
            delete remote[k];
          }
        }
      }
      for (k in remote) {
        v = remote[k];
        if (!local[k] && !local[k + ".html"]) {
          // Queue for deletion remote files that do not exist locally.
          dlist.push(k);
        }
      }
      // Queue for upload local files.
      if (force) {
        for (k in local) {
          v = local[k];
          // The "--force" flag overrides reconciliation and queues everything.
          ulist.push({
            file: k,
            hash: v
          });
        }
      } else {
        // Check for files lacking remote counterpart or SHA hash match.
        needsUpdate = function(k, h) {
          return !remote[k] || h !== remote[k].hash;
        };
        for (k in local) {
          v = local[k];
          if (needsUpdate(k, v)) {
            ulist.push({
              file: k,
              hash: v
            });
          }
          // For HTML files, we need to also check for files without extension.
          if (k.indexOf(".html") > -1 && !needsUpdate(k, v)) {
            obj = k.split(".html")[0];
            if (!remote[obj] || v !== remote[obj].hash) {
              ulist.push({
                file: k,
                hash: v
              });
            }
          }
        }
      }
      return {dlist, ulist};
    }
  };

}).call(this);
