// Generated by CoffeeScript 2.0.2
(function() {
  var async, context, define, events, find, go, http, httpLogger, isReadStream, join, map, mime, render, run, spread, tee;

  http = require("http");

  ({join} = require("path"));

  mime = require("mime-types");

  ({async, isReadStream, spread, events, go, map, tee} = require("fairmont"));

  ({define, run, context} = require("panda-9000"));

  ({find, render} = require("./asset"));

  httpLogger = function({request, response}) {
    var method, start, url;
    start = Date.now();
    ({url, method} = request);
    return response.on("finish", function() {
      var code, duration;
      duration = Date.now() - start;
      code = response.statusCode;
      return console.log(`${method} ${url} - ${code} (${duration}ms)`);
    });
  };

  define("serve", ["survey"], function() {
    var port, server, source, watcher;
    ({source, server} = require("./configuration"));
    watcher = require("chokidar");
    // re-run the survey when things change
    watcher.watch(source, {
      ignoreInitial: true
    }).on("all", function(event) {
      return run("survey");
    });
    http = require("http");
    port = (server != null ? server.port : void 0) != null ? server.port : 1337;
    server = http.createServer().listen(port, function() {
      return console.log(`Haiku9 HTTP server listening on port ${port}.`);
    });
    return go([
      events("request",
      server),
      map(spread(function(request,
      response) {
        return {request,
      response};
      })),
      tee(httpLogger),
      tee(async(function*({request,
      response}) {
        var asset,
      error,
      extension,
      path,
      target;
        try {
          ({path,
      source} = context("/",
      request.url.split('?')[0]));
          extension = source.extension === "" ? ".html" : source.extension;
          if (((asset = find({path, extension})) != null) || ((asset = find({
            path: join(path, "index"),
            extension
          })) != null)) {
            yield render(asset);
            ({target} = asset);
            response.setHeader("content-type",
      mime.lookup(target.extension));
            response.statusCode = 200;
            // if isReadStream target.content
            if (target.content.pipe != null) {
              return target.content.pipe(response);
            } else {
              return response.end(target.content);
            }
          } else {
            response.statusCode = 404;
            response.setHeader("content-type",
      "text/plain");
            return response.end("Not Found");
          }
        } catch (error1) {
          error = error1;
          console.error(error.stack);
          response.statusCode = 503;
          response.statusMessage = "Unknown server error";
          return response.end("Unknown server error");
        }
      }))
    ]);
  });

}).call(this);
